PreTeXt
=======

An authoring and publishing system for authors of textbooks, research articles, and monographs, especially in STEM disciplines.

GPL License.

Quickstart instructions at project website:  [pretextbook.org](https://pretextbook.org)

Help and development discussions:
* Support forum/mailing-list: [pretext-support](https://groups.google.com/forum/#!forum/pretext-support)
* Announcements only, low-volume: [pretext-announce](https://groups.google.com/forum/#!forum/pretext-announce)
* Submitting an issue is the last option for receiving help. See the [Contributing Guide](CONTRIBUTING.md).

PreTeXt is guided by the following principles:
----------------------------------------------
1. PreTeXt is a markup language that captures the structure of
textbooks and research papers.
2. PreTeXt is human-readable and human-writable.
3. PreTeXt documents serve as a single source which can be
easily converted to multiple other formats, current and future.
4. PreTeXt respects the good design practices which have been
developed over the past centuries.
5. PreTeXt makes it easy for authors to implement features which
are both common and reasonable.
6. PreTeXt supports online documents which make use of the full
capabilities of the Web.
7. PreTeXt output is styled by selecting from a list of available
templates, relieving the author of the burden involved
in micromanaging the output format.
8. PreTeXt is free: the software is available at no cost, with an
open license. The use of PreTeXt does not impose any constraints
on documents prepared with the system.
9. PreTeXt is not a closed system: documents can be converted to
LaTeX and then developed using standard LaTeX tools.
10. PreTeXt recognizes that scholarly documents involve the
interaction of authors, publishers, scholars, curators, instructors,
students, and readers, with each group having its own needs
and goals.
11. PreTeXt recognizes the inherent value in producing material
that is accessible to everyone.
